
#include "hcl.hpp"

extern "C" status_t newLocker (PClocker node, const char *path)
{
  *node=(Clocker)new BNode(path);
  return ((locker)*node)->InitCheck();
};

extern "C" status_t setLocker (Clocker node, const char *path)
{
  if (node!=NULL)
    return ((locker)node)->SetTo(path);
  else    
    return B_NO_INIT;
}

extern "C" status_t delLocker (PClocker node)
{
  delete (locker)*node;
  node=NULL;
  return B_OK;
}

extern "C" status_t statusLocker (Clocker node)
{
  if (node!=NULL) 
  {
    status_t status;
    if ((status=((locker)node)->Lock())!=B_BUSY)
      ((locker)node)->Unlock();
    return status; 
  }
  else    
    return B_NO_INIT;
}

extern "C" status_t LockLocker (Clocker node)
{
  if (node!=NULL) 
    return ((locker)node)->Lock();
  else    
    return B_NO_INIT;
}

extern "C" status_t UnlockLocker (Clocker node)
{
  if (node!=NULL) 
    return ((locker)node)->Unlock();
  else    
    return B_NO_INIT;
}

